aboutsummaryrefslogtreecommitdiffstats
path: root/package/kernel
diff options
context:
space:
mode:
authorJohn Crispin <john@openwrt.org>2014-04-12 21:22:17 +0000
committerJohn Crispin <john@openwrt.org>2014-04-12 21:22:17 +0000
commit3bc77db5f58e331fc524019d37f4a1c9eb82e2e9 (patch)
tree7dbba76368c83f07bcd72fef9baed8deaa992868 /package/kernel
parentfca3f32fe86b4b76d4006c7c1bee4a4defbd2c8f (diff)
downloadupstream-3bc77db5f58e331fc524019d37f4a1c9eb82e2e9.tar.gz
upstream-3bc77db5f58e331fc524019d37f4a1c9eb82e2e9.tar.bz2
upstream-3bc77db5f58e331fc524019d37f4a1c9eb82e2e9.zip
802.11s: fix authsae support in netifd
This patch implements support for 802.11s protected mesh wireless networks (using authsae) in the netifd framework. Until meshd-nl80211 implements a proper -P option for the PID file, this uses shell backgrounding in order to be able to get the PID for the process. Signed-off-by: Vittorio Gambaletta <openwrt@vittgam.net> SVN-Revision: 40497
Diffstat (limited to 'package/kernel')
-rw-r--r--package/kernel/mac80211/files/lib/netifd/wireless/mac80211.sh15
1 files changed, 14 insertions, 1 deletions
diff --git a/package/kernel/mac80211/files/lib/netifd/wireless/mac80211.sh b/package/kernel/mac80211/files/lib/netifd/wireless/mac80211.sh
index c5d3482499..53d1cb9c8f 100644
--- a/package/kernel/mac80211/files/lib/netifd/wireless/mac80211.sh
+++ b/package/kernel/mac80211/files/lib/netifd/wireless/mac80211.sh
@@ -449,6 +449,7 @@ mac80211_setup_adhoc() {
mac80211_setup_vif() {
local name="$1"
+ local failed
json_select data
json_get_vars ifname
@@ -473,7 +474,19 @@ mac80211_setup_vif() {
json_get_var mp_val "$var"
[ -n "$mp_val" ] && iw dev "$ifname" set mesh_param "$var" "$mp_val"
done
- # todo: authsae
+
+ # authsae
+ json_get_vars key
+ if [ -n "$key" ]; then
+ if [ -e "/lib/wifi/authsae.sh" ]; then
+ . /lib/wifi/authsae.sh
+ authsae_start_interface || failed=1
+ else
+ wireless_setup_vif_failed AUTHSAE_NOT_INSTALLED
+ json_select ..
+ return
+ fi
+ fi
;;
adhoc)
wireless_vif_parse_encryption